freeslot("MT_PCM", "S_GOOP99", "MT_HOMINGMISSILE", "S_HOMINGMISSILE", "MT_SPIKESHIELDCENT", "S_SSC")
mobjinfo[MT_PCM] = {
	spawnstate = S_THOK,
	deathstate = S_NULL,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	spawnhealth = 99999,
	flags = MF_NOCLIPTHING|MF_NOCLIPHEIGHT|MF_NOCLIP|MF_NOGRAVITY
	}
states[S_HOMINGMISSILE] = {
	sprite = SPR_TORP,
    tics = 245,
    action = A_SmokeTrailer,
    nextstate = S_DEATHSTATE
	}
states[S_SSC] = {
	sprite = SPR_THOK,
    tics = 175,
    action = A_CapeChase,
    nextstate = S_NULL
	}
mobjinfo[MT_SPIKESHIELDCENT] = {
	spawnstate = S_SSC,
	deathstate = S_NULL,
	radius = 8*FRACUNIT,
	height = 8*FRACUNIT,
	spawnhealth = 99999,
	flags = MF_NOGRAVITY|MF_NOCLIPTHING|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_SLIDEME
	}
mobjinfo[MT_HOMINGMISSILE] = {
	spawnstate = S_HOMINGMISSILE,
	deathstate = S_RINGEXPLODE,
	radius = 11*FRACUNIT,
	height = 8*FRACUNIT,
	spawnhealth = 99999,
	flags = MF_MISSILE|MF_NOGRAVITY
	}
states[S_GOOP99] = {
	sprite = SPR_GOOP,
    tics = 4,
    action = A_PlayAttackSound,
    nextstate = S_GOOP3
	}
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		mo.flags2 = $|MF2_DONTDRAW
		if not mo.spawnedthings then
			mo.timer = 170
			mo.otherangle = mo.angle
			mo.v1 = P_SpawnMobjFromMobj(mo, 0, 0, mo.height, MT_POINTYBALL)
			mo.v1.target = mo.target
			mo.v1.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
			mo.v2 = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_POINTYBALL)
			mo.v2.target = mo.target
			mo.v2.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
			mo.spawnedthings = true
		else
			mo.timer = $ - 1
			if mo.timer < 4 then
				P_KillMobj(mo.v1)
				P_KillMobj(mo.v2)
				P_KillMobj(mo)
				return
				end
			mo.angle = $ + (ANG20/4)
			mo.otherangle = $ + (ANG20)
			if mo.v1 and mo.v1.valid
				local ball = mo.v1
				local ghost = P_SpawnGhostMobj(ball)
				ghost.fuse = 5
				ghost.flags = $|MF_SHOOTABLE
				ghost.radius = mo.radius
				ghost.height = mo.height
				ball.sprite = SPR_UNID
				local tx = FixedMul(50 * mo.scale, sin(mo.angle))
				local ty = FixedMul(50 * mo.scale, cos(mo.angle))
				local tz = FixedMul(25 * mo.scale, cos(mo.otherangle))
				P_SetOrigin(ball, mo.target.x + tx, mo.target.y + ty, mo.target.z + tz)
				
				end
			if mo.v2 and mo.v2.valid
				local ball = mo.v2
				local ghost = P_SpawnGhostMobj(ball)
				ghost.fuse = 5
				ghost.flags = $|MF_SHOOTABLE
				ghost.radius = mo.radius
				ghost.height = mo.height
				ball.sprite = SPR_UNID
				local tx = FixedMul(50 * mo.scale, cos(mo.angle))
				local ty = FixedMul(50 * mo.scale, sin(mo.angle))
				local tz = FixedMul(25 * mo.scale, sin(mo.otherangle))
				P_SetOrigin(ball, mo.target.x + tx, mo.target.y + ty, mo.target.z + tz)
				end
			end
		end
	end, MT_SPIKESHIELDCENT)
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.tracer == nil or leveltime%60 == 0 then
			for mo2 in mobjs.iterate() do
				if mo2 and mo2.valid and (mo2.flags & MF_ENEMY or mo2.flags & MF_BOSS) and mo2 != mo and mo2 != mo.target then
					if R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y) < mo.scale * 250 then
						if mo.z < mo2.z + (mo.scale * 200) and mo.z > mo2.z - (mo.scale * 200) then
							mo.tracer = mo2
							break
							end
						end
					end
				if mo2 and mo2.valid and (mo2.flags & MF_MONITOR or mo2.flags & MF_SHOOTABLE) and mo2 != mo and mo2 != mo.target and mo2.type != MT_PLAYER then
					if R_PointToDist2(mo.x, mo.y, mo2.x, mo2.y) < mo.scale * 100 then
						if mo.z < mo2.z + (mo.scale * 75) and mo.z > mo2.z - (mo.scale * 75) then
							mo.tracer = mo2
							break
							end
						end
					end
				end
			end
		for p in players.iterate do
			if not MEGAMAN.pvpcheck(mo.target.player, p) then continue end
			if p and p.mo and p.mo.valid then
				if p.mo == mo.target then continue end
				if R_PointToDist2(mo.x, mo.y, p.mo.x, p.mo.y) < mo.scale * 100 then
					if mo.z < p.mo.z + (mo.scale * 75) and mo.z > p.mo.z - (mo.scale * 75) then
						mo.tracer = p.mo
						end
					end
				end
			end
		if mo.tracer then
			local ghost = P_SpawnGhostMobj(mo)
			ghost.state = S_JETFUME1
			ghost.fuse = 5
			ghost.scale = $ / 3
			ghost.blendmode = AST_ADD
			local ang = R_PointToAngle2(mo.x, mo.y, mo.tracer.x, mo.tracer.y)
			mo.angle = ang
			P_InstaThrust(mo, mo.angle, max((R_PointToDist2(mo.x,mo.y, mo.tracer.x, mo.tracer.y)/10), mo.scale * 5))
			P_SetObjectMomZ(mo, (mo.tracer.z - mo.z) /20, false)
			end
		end
	end, MT_HOMINGMISSILE)
addHook("MobjThinker", function(mo)
	if mo and mo.valid
		if mo.id != nil then
			if mo.weaponid == 1 then
				for i = 0,2 do 
					local laser = P_SpawnMobjFromMobj(mo, 0,0,0, MT_LASER)
					P_InstaThrust(laser, mo.angle + (ANGLE_11hh * (i - 1)), (mo.target.scale * MEGAMAN.WEP[0][1].speed) + (mo.target.player.speed/2))
					laser.angle = mo.angle + (ANGLE_11hh * (i - 1))
					laser.state = S_MAGNETBEAM
					laser.sprite = SPR_MISL
					laser.target = mo.target
					laser.fuse = 900
					end
				P_KillMobj(mo)
				return
				end
			if mo.weaponid == 2 then
				local goop = P_SpawnMobjFromMobj(mo, mo.momx/2, mo.momy/2,0, MT_GOOP)
				P_InstaThrust(goop, mo.angle, (mo.target.scale * MEGAMAN.WEP[0][2].speed) + (mo.target.player.speed/2))
				goop.angle = mo.angle
				goop.target = mo.target
				goop.flags = MF_MISSILE|MF_BOUNCE|MF_GRENADEBOUNCE|MF_SPRING
				goop.info.mass = 8 * FU
				goop.info.attacksound = sfx_spring
				goop.info.raisestate = S_GOOP99
				goop.fuse = 150
				P_KillMobj(mo)
				return
				end
			if mo.weaponid == 5 then
				if mo.state != S_HOMINGMISSILE
					mo.state = S_HOMINGMISSILE
					mo.sprite = SPR_THOK
					mo.fuse = -1
					end
				mo.flags2 = $|MF2_DONTDRAW
				if not mo.spawn
					mo.angled = mo.angle
					mo.p1 = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK) 
					mo.p2 = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK) 
					mo.p1.angle = mo.angle
					mo.p2.angle = mo.angle
					mo.p1.scale = mo.scale - (mo.scale / 3)
					mo.p2.scale = mo.scale - (mo.scale / 3)
					mo.p1.radius = mobjinfo[MT_CORK].radius
					mo.p1.height = mobjinfo[MT_CORK].height * 2
					mo.p2.radius = mobjinfo[MT_CORK].radius
					mo.p2.height = mobjinfo[MT_CORK].height * 2
					mo.p1.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					mo.p2.flags = MF_MISSILE|MF_NOGRAVITY|MF_NOCLIPHEIGHT
					mo.p1.target = mo.target
					mo.p2.target = mo.target
					mo.p1.fuse = 250
					mo.p2.fuse = 250
					mo.p1.state = S_CORK
					mo.p2.state = S_CORK
					mo.spawn = true
				else
					local p1 = mo.p1
					local p2 = mo.p2
					mo.angled = $ + ANG30
					if p1 and p1.valid then
						local tx = FixedMul(mo.scale * 10, sin(mo.angled))
						local ty = FixedMul(mo.scale * 10, cos(mo.angled))
						P_SetOrigin(p1, mo.x + tx, mo.y + ty, mo.z)
						local ghost = P_SpawnGhostMobj(p1)
						ghost.fuse = 7
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_AETHER
						ghost.destscale = 0
						end
					if p2 and p2.valid then
						local tx = FixedMul(mo.scale * -10, sin(mo.angled))
						local ty = FixedMul(mo.scale * -10, cos(mo.angled))
						P_SetOrigin(p2, mo.x + tx, mo.y + ty, mo.z)
						local ghost = P_SpawnGhostMobj(p2)
						ghost.fuse = 7
						ghost.blendmode = AST_ADD
						ghost.color = SKINCOLOR_AETHER
						ghost.destscale = 0
						end
					end
				return
				end
			if mo.weaponid == 7 then
				if not mo.set then
					mo.timer = 5 * TICRATE
					mo.set = true
					end
				if mo.target and mo.target.valid
					if mo.state == S_THOK
						mo.state = S_CYBRAKDEMONELECTRICBARRIER1
						mo.health = 70
						end
					if mo.target.type == MT_PLAYER and mo.target.player
						local p = mo.target.player
						mo.prevowner = mo.target
						p.powers[pw_strong] = STR_PUNCH|STR_HEAVY|STR_WALL|STR_FLOOR|STR_SPIKE|STR_STOMP|STR_DASH
						p.pflags = $|PF_GODMODE
						end
					if mo.prevowner != mo.target then
						local p = mo.prevowner.player
						p.powers[pw_strong] = STR_NONE
						p.pflags = $&~PF_GODMODE
						end
					P_SetOrigin(mo, mo.target.x, mo.target.y, mo.target.z)
					mo.scale = mo.target.scale
					mo.radius = mo.target.radius * 2
					mo.flags = MF_NOCLIPHEIGHT|MF_NOGRAVITY
					
					mo.timer = $ - 1
					local sector = mo.subsector.sector
					for rover in sector.ffloors() do
						if rover.flags & FOF_SWIMMABLE and P_InsideANonSolidFFloor(mo, rover) and leveltime%4 == 0 then
							if mo.target.type == MT_PLAYER and mo.target.player
								local p = mo.target.player
								P_DamageMobj(p.mo)
								p.mm.health = max($ - 1, 1)
								p.mo.state = S_PLAY_PAIN
								p.mm.stun = 20
								p.powers[pw_nocontrol] = 20
								P_SetObjectMomZ(p.mo, p.mo.scale * 20, false)
								p.powers[pw_strong] = STR_NONE
								p.pflags = $&~PF_GODMODE
								for i = 0,4 do
									local paind = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z + p.mo.height, MT_MMDUST)
									local pax = p.mo.x + ((45 - P_RandomRange(0,90)) *p.mo.scale)
									local pay = p.mo.y + ((45 - P_RandomRange(0,90)) *p.mo.scale)
									P_SetOrigin(paind, pax, pay, paind.z)
									paind.scale = p.mo.scale + (FU*2 + FU/2)
									paind.sprite = SPR_MPF0 + P_RandomRange(0,2)
									paind.angle = camera.angle + ANGLE_90
									end
								end
							S_StartSound(mo, sfx_s3k45)
							end
						end
					if mo.timer < 1 
						if mo.target.type == MT_PLAYER and mo.target.player
							local p = mo.target.player
							p.powers[pw_strong] = STR_NONE
							p.pflags = $&~PF_GODMODE
							end
						P_KillMobj(mo)
						end
					end
				return
				end
			if mo.weaponid == 8 then
				if not mo.springed
					local spring = P_SpawnMobjFromMobj(mo, mo.momx, mo.momy, mo.momz, MT_BLUESPRING)
					spring.scale = mo.target.scale
					P_InstaThrust(spring, mo.angle, (mo.target.scale * (MEGAMAN.WEP[0][8].speed/3)) + (mo.target.player.speed/2))
					spring.fuse = 200
					P_SetObjectMomZ(spring, mo.target.scale * 3, false)
					spring.angle = mo.angle
					spring.flags = $|MF_SLIDEME|MF_BOUNCE
					spring.color = SKINCOLOR_RUSH
					spring.colorized = true
					mo.springed = true
					P_KillMobj(mo)
					end
				return
				end
			end
		end
	end, MT_PCM)
				